section(anchor='s-grbl')
  name Grbl

  t
    | SAMbuCa Grbl implementation is based on #[xref(target='GRBL_HAL') Grbl-Hal]
    | open-source project.

  section
    name MGrbl

    t
      | Depending on its usage, motion-control requires some axis to be independent,
      | to achieve this multiple instances of #[xref(target='GRBL_HAL') Grbl-Hal] are
      | running on the #[xref(target='s-apu0') Application Processing Unit].

    t
      | To achieve this on a #[eref(target='https://en.wikipedia.org/wiki/Bare_machine') bare metal] system,
      | a collaborative multi-threading approach based on #[xref(target='LIBUCONTEXT') ucontext library] has been used.
    t
      | Each Grbl instance #[bcp14 MUST] be dispatched at least once every #[tt 40 milliseconds], to properly feed
      | the step-buffer.

    t
      | incoming and outgoing Grbl communication #[bcp14 MUST] be prefixed by
      | its instance number (using the ascii character representing the instance),
      | ranging from #[tt="'[0, 8]'"].
    t
      | In a similar way, communication with the control part #[bcp14 MUST] be
      | prefixed with ascii character #[tt C].

    t
      | See project reports and documentation for further details:
      | #[eref(target='https://gitlab.cern.ch/mro/controls/sambuca/vitis/sambuca-vitis/-/blob/master/docs/Architecture.md') here]

    section
      name Control Commands

      t
        | The following commands #[bcp14 MUST] be implemented by the control part
        | (each command #[bcp14 MUST] be acknowledged by "ok" or "error:num"):

      table(align='center')
        name MGrbl Control Commands
        thead
          tr
            th Command
            th Example Reply
            th Description
        tbody
          tr
            td $grblCount
            td
              tt $grblCount=8
            td Query the amount of Grbl instances available.
          tr
            td $I
            td
              tt
                | [VER:1.0]
                | [INSTANCES:8]
            td Query build information
          tr
            td $layout
            td
              tt $layout=01234567
            td Query current layout, each digit represents an axis [XYZABCUV] and maps an axis to an instance.
          tr
            td $layout=01234567
            td
            td Modify current layout, each digit represents an axis [XYZABCUV] and maps an axis to an instance.